#include "thint.h"

int fu(int32 a)
{
   float b;

   printf("func %d\n", a);

   b = 1.3;

   printf("b + 1.1 = %f\n", b + 1.1);

   return 3;
}

void test_string()
{
   string a = "abcdefg,var=\"haha\",var2=234";
   string b,c,d,e;

   printf("\nString test\n\n");

   printf("a = %s\n\n", a);

   THStr_Substring(b, a, 2, 5);
   printf("substring(b, a, 2, 5) result b = %s\n", b);

   if(b == "cde")
      printf("string b is equals \"cde\"\n");
   else
      printf("string b is not equals \"cde\"\n");


   THStr_TokenValue(c, a, "var", '=', ',');
   printf("TokenValue var = %s\n", c);
   THStr_TokenValue(c, a, "var2", '=', ',');
   printf("TokenValue var2 = %s\n", c);

   THStr_GetTokenValue(a, strlen(a), "var", 3, d);
   printf("GetTokenValue var = %s\n", d);
   THStr_GetTokenValue(a, strlen(a), "var2", 4, d);
   printf("GetTokenValue var2 = %s\n", d);

   printf("\n\nString test end\n");
}

void test_memory()
{
   string a, d;
   int b, c;
   int64 i;

   printf("\nMemory test\n\n");
   a = malloc(4);

   b = 3;

   printf("int to string\n");
   memcpy(a, b, 4, 0, 0);

   printf("string to int\n");
   memcpy(c, a, 4, 0, 0);

   printf("result c = %d\n", c);

   c = 2;
   printf("memcmp(a,2, 4, 0, 0) = %d\n", memcmp(a, c, 4, 0, 0));

   d = malloc(8);
   c = 2;
   memcpy(d, c, 4, 0, 0);
   c = 5;
   memcpy(d, c, 4, 4, 0);

   memcpy(b, d, 4, 0, 0);
   printf("b = %d\n", b);
   memcpy(b, d, 4, 0, 4);
   printf("b = %d\n", b);

   memcpy(i, d, 8, 0, 0);
   printf("i64 = %D\n", i);

   printf("\n\nMemory test end\n");
}

void test_dir()
{
   handle dHandle;
   handle dEntry;
   byte bRet = 1;
   int a;
   string fname;

   dHandle = dopen("/etc/*");
   if(disfailed(dHandle))
   {
      printf("Can not open dir\n");
      return;
   }

   while(bRet)
   {
      bRet = dnextentry(dHandle, dEntry);
      if(bRet == 0) break;
      fname = dentryfullpath(dEntry);
      printf("filename: %s\n", fname);
      dentryclose(dEntry);
   }
   dclose(dHandle);
}

main()
{
   int32 a,b,c,d, r;
   bigfloat x1r,x2r,x3r;
   bigfloat x1i,x2i,x3i;
   bigfloat v;
   handle hHandle;


   printf("load lib\n");
   hHandle = LoadLibrary("./testplugin.so");

   if(handletype(hHandle) == HANDLE_TYPE_ERROR)
   {
      printf("Handle failed\n");
   }
   else
   {
      a = plugin_sum(23, 11);
      printf("plugin_sum(23,11) = %d\n", a);
      printf("plugin_mul(23,11) = %d\n", plugin_mul(23,11));
      FreeLibrary(hHandle);
   }

   a = 1;
   b = 2;
   c = 5;
   d = -3;

   printf("a=%d, b=%d, c=%d, d=%d\n", a,b,c,d);

   if(a==2)
      printf("a=2\n");
   else
      for(r=0; r<3; r = r+1)
         if(r==0)
            printf("r = %d\n", r);
         else if(r==2)
            printf("r2 = %d\n", r);
         else fu(r);

   printf("Start\n");

   printf("a=%d, b=%d, c=%d, d=%d\n", a,b,c,d);

   // r = equation_1(c, d, x1r);
   // r = equation_2(b , c, d, x1r, x2r);
   r = equation_3(a,b,c,d, 0, x1r, x1i, x2r, x2i, x3r, x3i);

   printf("equation_2 result = %d\n", r);

   if(r == 0)
      printf("Error\n");
   else
      //  
      if(r == 1)
      {
         printf("%dx + %d = 0\nx = %f\n", c, d, x1r);
         v = (c * x1r) + d;
         printf("Verify: %f\n", v);
      }
      //  
      else if((r == 2) || (r == 3))
      {
         printf("%dx2 + %dx + %d = 0\nx1 = %f, x2 = %f\n", b, c, d, x1r, x2r);

         v = (b * (x1r * x1r)) + (c * x1r) + d;
         printf("Verify: %f\n", v);
         v = (b * (x2r * x2r)) + (c * x2r) + d;
         printf("Verify: %f\n", v);
      }
      else if(r == 4)
         printf("%dx2 + %dx + %d = 0\nx1 = %f + i * %f, x2 = %f - i * %f\n", b, c, d, x1r, x2r, x1r, x2r);
      // 
      else if(r == 5)
      {
         printf("%dx3 + %dx2 + %dx + %d = 0\n", a,b,c,d);
         printf("x1 = %f + i * %f\n", x1r, x1i);
         printf("x2 = %f + i * %f\n", x2r, x2i);
         printf("x3 = %f + i * %f\n", x3r, x3i);
      }
      else if(r == 6)
      {
         printf("%dx3 + %dx2 + %dx + %d = 0\n", a,b,c,d);
         printf("x1 = %f ( cos(%f) + i * sin(%f) )\n", x1r, x1i, x1i);
         printf("x2 = %f ( cos(%f) + i * sin(%f) )\n", x2r, x2i, x2i);
         printf("x3 = %f ( cos(%f) + i * sin(%f) )\n", x3r, x3i, x3i);
      }
      else
         printf("Error r=%d\n", r);

   printf("test_string()\n");
   test_string();

   printf("test_memory()\n");
   test_memory();

   printf("test_dir()\n");
   test_dir();
}
