#include "thint.h"

void print_hex(string str, string val, string buf, int32 maxlen)
{
   int32 count;
   byte btch;

   printf("%s(%s)\n", str, val);
   for(count=0; count<maxlen; count++)
   {
      btch = THStr_CharAt(buf, count);
      if(((count + 1) % 8) == 0)
      {
         printf("%x\n", btch);
      }
      else
      {
         printf("%x ", btch);
      }
   }
   printf("\n");
}

void do_ecb(string plaintext, string key)
{
   handle cHandle;
   string enctext;
   string dectext;
   int32 enclen;
   int32 declen;

   cHandle = Crypt_Init(TH_CRYPT_ALG_DES, key, strlen(key), 8, "");
   Crypt_DoCipher(cHandle, TH_CRYPT_MODE_ECB, TRUE, plaintext, sizeof(plaintext), enctext, enclen);
   print_hex("Encrypt", "ECB", enctext, enclen);
   Crypt_Reset(cHandle);
   Crypt_DoCipher(cHandle, TH_CRYPT_MODE_ECB, FALSE, enctext, enclen, dectext, declen);
   print_hex("Decrypt", "ECB", dectext, declen);
   Crypt_Free(cHandle);
}

void do_cbc(string plaintext, string key)
{
   handle cHandle;
   string enctext;
   string dectext;
   int32 enclen;
   int32 declen;

   cHandle = Crypt_Init(TH_CRYPT_ALG_DES, key, strlen(key), 8, "12345678");
   Crypt_DoCipher(cHandle, TH_CRYPT_MODE_CBC, TRUE, plaintext, sizeof(plaintext), enctext, enclen);
   print_hex("Encrypt", "CBC", enctext, enclen);
   Crypt_Reset(cHandle);
   Crypt_DoCipher(cHandle, TH_CRYPT_MODE_CBC, FALSE, enctext, enclen, dectext, declen);
   print_hex("Decrypt", "CBC", dectext, declen);
   Crypt_Free(cHandle);
}

void do_cfb(string plaintext, string key)
{
   handle cHandle;
   string enctext;
   string dectext;
   int32 enclen;
   int32 declen;

   cHandle = Crypt_Init(TH_CRYPT_ALG_DES, key, strlen(key), 8, "12345678");
   Crypt_DoCipher(cHandle, TH_CRYPT_MODE_CFB, TRUE, plaintext, sizeof(plaintext), enctext, enclen);
   print_hex("Encrypt", "CFB", enctext, enclen);
   Crypt_Reset(cHandle);
   Crypt_DoCipher(cHandle, TH_CRYPT_MODE_CFB, FALSE, enctext, enclen, dectext, declen);
   print_hex("Decrypt", "CFB", dectext, declen);
   Crypt_Free(cHandle);
}

main()
{
   string plaintext = "12345678123456781234567812345678";
   string key = "12345678";

   print_hex("Plain", "CFB", plaintext, sizeof(plaintext));

   do_ecb(plaintext, key);
   getchar();

   do_cbc(plaintext, key);
   getchar();

   do_cfb(plaintext, key);
}
