#include "thint.h"

main(string argv[])
{
   handle	hArchive;
   handle	hArchiveEntry;
   handle	hArchiveFile;
   int32	htype;
   int32	ret;

   string	strFilename;
   int64	filesize;

   if(argv.length != 2)
   {
      printf("Usage: %s archive-file\n", argv[0]);
      exit(1);
   }

   hArchive = ArchiveManager_Create();
   htype = handletype(hArchive);
   if(htype != HANDLE_TYPE_ARCHIVE)
   {
      printf("%s: can not create archive manager\n", argv[0]);
      exit(1);
   }

   ret = ArchiveManager_Open(hArchive, argv[1], TH_ARCHIVE_MANAGER_OPEN_READ);
   if(ret == FALSE)
   {
      printf("%s: can not open file %s\n", argv[0], argv[1]);
      exit(1);
   }

   hArchiveEntry = ArchiveManager_GetFirstEntry(hArchive);
   htype = handletype(hArchiveEntry);
   printf("entry type = %d\n", htype);
   while(handletype(hArchiveEntry) == HANDLE_TYPE_ARCHIVE_ENTRY)
   {
      strFilename = ArchiveEntry_GetFilename(hArchiveEntry);
      filesize    = ArchiveEntry_GetSize(hArchiveEntry);
      printf("entry filename = %s filesize = %d\n", strFilename, filesize);

      hArchiveEntry = ArchiveManager_GetNextEntry(hArchiveEntry);
   }
   ArchiveManager_Close(hArchive);
}
