#include "thint.h"

void print_hex(string str, string val, string buf, int32 maxlen)
{
   int32 count;
   byte btch;

   printf("%s(%s) = ", str, val);
   for(count=0; count<maxlen; count++)
   {
      btch = THStr_CharAt(buf, count);
      printf("%x ", btch);
   }
   printf("\n");
}

void memtest()
{
   string packed;
   int32	a1, a2, a3;
   int8 a4;
   string str;

   printf("\n\nmemtest]n");
   packed = mempack(0x61, 0x62, 0x63, "1234");
   print_hex("packed", "61,62,63", packed, sizeof(packed));

   str = malloc(4);
   memunpack(packed, a1, a2, a3, a4, str);
   printf("a1 = %x\n", a1);
   printf("a2 = %x\n", a2);
   printf("a3 = %x\n", a3);
   printf("a4 = %x\n", a4);
   printf("str = %s\n", str);
}

void urlencode()
{
   string plain_uri = "abc1234_.t e x t";
   string encoded;
   string decoded;

   printf("\n\nURL Encode\n");
   printf("PlainText: %s\n", plain_uri);

   encoded = THStr_URLEncode(plain_uri, TH_URLENCODE_DEFAULT);
   printf("Encoded DEFAULT: %s\n", encoded);

   decoded = THStr_URLDecode(encoded);
   printf("Decoded: %s\n", decoded);

   encoded = THStr_URLEncode(plain_uri, TH_URLENCODE_ASCII);
   printf("Encoded ASCII: %s\n", encoded);

   decoded = THStr_URLDecode(encoded);
   printf("Decoded: %s\n", decoded);

   encoded = THStr_URLEncode(plain_uri, TH_URLENCODE_SPECIAL);
   printf("Encoded SPECIAL: %s\n", encoded);

   decoded = THStr_URLDecode(encoded);
   printf("Decoded: %s\n", decoded);

   encoded = THStr_URLEncode(plain_uri, TH_URLENCODE_NUMBER);
   printf("Encoded NUMBER: %s\n", encoded);

   decoded = THStr_URLDecode(encoded);
   printf("Decoded: %s\n", decoded);

   encoded = THStr_URLEncode(plain_uri, TH_URLENCODE_HEIGHT);
   printf("Encoded HEIGHT: %s\n", encoded);

   decoded = THStr_URLDecode(encoded);
   printf("Decoded: %s\n", decoded);

   encoded = THStr_URLEncode(plain_uri, TH_URLENCODE_ALL);
   printf("Encoded ALL: %s\n", encoded);

   decoded = THStr_URLDecode(encoded);
   printf("Decoded: %s\n", decoded);
}

main(string argv[])
{
   string src = "\x00\x30\xde\x01\x30\xdf\x00\x35\xe3\x01\xe2\xdd\x03\x20\xdc\x06";
   string dest;
   byte btch;
   int srclen, destlen;
   int count;

   printf("arg count = %d\n", argv.length);
   for(count=0; count<argv.length; count++)
      printf("arg = %s\n", argv[count]);

   srclen = sizeof(src);
   dest = BITPROC_MakeBitString(src, srclen, 1, TH_BITPROC_LSB, 1);
   // dest = BITPROC_RightShiftString(src, 3);
   // dest = BITPROC_LeftShiftString(src, 3);
   destlen = sizeof(dest);

   printf("srclen = %d\n", srclen);
   printf("dest size = %d\n", destlen);

   printf("Src Hex = ");
   for(count=0; count<srclen; count++)
   {
      btch = THStr_CharAt(src, count);
      printf("%b(0x%x) ", btch, btch);
   }
   printf("\n");

   printf("Dest Hex = ");
   for(count=0; count<destlen; count++)
   {
      btch = THStr_CharAt(dest, count);
      printf("%b(0x%x) ", btch, btch);
   }
   printf("\n");

   printf("SRC = %s\n", src);
   dest = THStr_BASE64Encode(src, srclen);
   printf("BASE64 Dest = %s\n",dest);
   dest = THStr_BASE64Decode(dest, sizeof(dest));
   printf("BASE64 Dest = %s\n",dest);
   printf("encoding = %d\n", THStr_DetectEncoding(src, srclen));

   memtest();
   urlencode();
}

